## geany-plugins 0.21.1

=== debian/changelog ===
geany-plugins (0.21.1-3) unstable; urgency=low

  * [ddaf0ad] add new packages to Depends of the geany-plugins metapackage
  * [abe38e1] Fix FTBFS due to hardcoded amd64 path (Closes: #649502)

 -- Evgeni Golov <evgeni@debian.org>  Mon, 21 Nov 2011 19:16:08 +0100

geany-plugins (0.21.1-2) unstable; urgency=low

  * [304083c] call dh_install with --list-missing
  * [b89b54d] fix linking of debugger and geanypg with --as-needed
  * [412c733] add libgpgme11-dev and libvte-dev to build-depends
  * [5d3bb00] enable new plugins
  * [9e7f591] create packages for new plugins
  * [ab1e03c] install more docs into the packages
  * [b57a5ea] update copyright

 -- Evgeni Golov <evgeni@debian.org>  Sun, 20 Nov 2011 17:26:23 +0100

geany-plugins (0.21.1-1) unstable; urgency=low

  [ Evgeni Golov ]
  * [f4007f2] Imported Upstream version 0.21.1
  * [5ff622d] install plugins from/to /usr/lib/<arch-triplet>/geany
  * [75411d7] bump build-dep to geany 0.21
  * [db92155] depend on the virtual geany-abi-XX package
  * [dd84769] switch to 3.0 (quilt)
  * [3ab76d7] drop readme.source
  * [233d44c] refresh patch against 0.21.1
  * [030bec1] add lintian override for
              documentation-package-not-architecture-independent
  * [aba43d7] use debhelper compat level 9

 -- Evgeni Golov <evgeni@debian.org>  Thu, 17 Nov 2011 20:03:24 +0100

geany-plugins (0.20-3) unstable; urgency=low

  [ Chow Loong Jin ]
  * [7207010] Don't install .la files (Closes: #621163)

  [ Evgeni Golov ]
  * [fd8d00d] Swap libwebkit-dev and libwebkitgtk-dev (Closes: #635408)
  * [b274e54] Don't ship /usr/lib/geany-plugins/geanylua/libgeanylua.la either
  * [8044cb8] fix lintian's debian-watch-contains-dh_make-template
  * [b8f62a6] Standards-Version: 3.9.2
  * [93c2d9f] fix lintian's description-synopsis-starts-with-article

 -- Evgeni Golov <evgeni@debian.org>  Tue, 26 Jul 2011 12:06:28 +0200

geany-plugins (0.20-2) unstable; urgency=low

  * [2a4fca9] Add updatechecker and webhelper plugin packages
  * [8cdf50c] Update build-depends
  * [e4de909] Add enable flags for all plugins during configure
  * [bdfaa13] No change Standards-Version bump from 3.9.0 to 3.9.1
  * [4c528b3] Update copyright file
  * [88ad6ef] Revert "Disable gendoc for Squeeze."
  * [a7dac51] Revert "Disable *all* the new plugins for now."
  * [c096ce6] Depend on libwebkit-dev or libwebkitgtk-dev
  * [efac459] Disable dh_makeshlibs

 -- Chow Loong Jin <hyperair@ubuntu.com>  Wed, 30 Mar 2011 23:01:45 +0800

geany-plugins (0.20-1) unstable; urgency=low

  * [71f0af3] New upstream release
    + Fixes build failuers with Geany 0.20 (Closes: #618078)
  * [8b2a095] Update copyright file

 -- Chow Loong Jin <hyperair@ubuntu.com>  Wed, 30 Mar 2011 01:17:20 +0800

geany-plugins (0.19-1) unstable; urgency=low

  [ Chow Loong Jin ]
  * New upstream release
    + Builds against geany 0.19 (Closes: #590346, #587141)
  * debian/control, debian/rules:
    + Shift geany dependency to geany-plugins-common instead, since it's a
      common dependency for all plugins
  * debian/control:
    + Add new packages for codenav, extrasel, gendoc, insertnum,
      prettyprinter and treebrowser plugins
    + Update build-deps:
      - Bump geany dependency to 0.19. (Closes: #573318)
      - Add libctpl-dev and python-docutils for geanygendoc
      - Add libxml2-dev for prettyprinter
    + No-change bump of Standards-Version from 3.8.3 to 3.9.0
    + Tighten dependency on geany-plugins-common (= instead of >=)
    + Add a Breaks on all geany-plugin-* packages prior to this version to
      ensure geany-plugins-common and geany-plugin-* versions match
  * debian/geany-plugin-codenav.{docs,install},
    debian/geany-plugin-extrasel.{docs,install},
    geany-plugin-gendoc.{docs,install},
    geany-plugin-insertnum.{docs,install},
    geany-plugin-prettyprinter.install
    geany-plugin-treebrowser.{docs,install}:
    + Install plugin files into individual packages

  [ Evgeni Golov ]
  * debian/control:
    + Disable the new plugins for now.
      If you want to build them localy, just uncomment them.
    + Don't D-B on libctpl-dev (it's not in Debian yet).
    + Add myself to Uploaders.
    + Standards-Version: 3.9.1
  * debian/copyright:
    + Update to include latest plugins.

 -- Evgeni Golov <evgeni@debian.org>  Sat, 04 Sep 2010 23:05:00 +0200

geany-plugins (0.18-2) unstable; urgency=low

  * debian/control:
    + Corrected spelling error in geany-plugin-addons' description
  * debian/control,
    debian/geany-plugin-doc.*,
    debian/geany-plugin-prj.*:
    + Added geany-plugin-doc and geany-plugin-prj packages

 -- Chow Loong Jin <hyperair@ubuntu.com>  Wed, 11 Nov 2009 07:35:44 +0800

geany-plugins (0.18-1) unstable; urgency=low

  * New upstream release
  * debian/control: Bump Standards-Version to 3.8.3 (no changes)
  * debian/(control, rules):
    + Automatically get Geany version for binary depends during build time.
  * debian/README.source: Copied from /usr/share/doc/quilt

 -- Chow Loong Jin <hyperair@ubuntu.com>  Sat, 07 Nov 2009 16:18:37 +0800

geany-plugins (0.17.1-1) unstable; urgency=low

  * Initial release (Closes: #536499)

 -- Chow Loong Jin <hyperair@ubuntu.com>  Fri, 10 Jul 2009 22:56:41 +0800

=== debian/control ===
Source: geany-plugins
Section: devel
Priority: optional
Maintainer: Geany Packaging Team <pkg-geany-team@lists.alioth.debian.org>
Uploaders: Chow Loong Jin <hyperair@ubuntu.com>, Evgeni Golov <evgeni@debian.org>
Build-Depends: debhelper (>= 8.9.0~),
               autotools-dev,
               intltool (>= 0.35),
               geany (>= 0.21),
               libgtk2.0-dev (>= 2.16),
               libglib2.0-dev (>= 2.18),
               libenchant-dev (>= 1.3),
               libgtkspell-dev,
               liblua5.1-dev,
               libctpl-dev (>= 0.3),
               python-docutils,
               libxml2-dev (>= 2.6.27),
               libsoup2.4-dev (>= 2.4.0),
               libwebkitgtk-dev (>= 1.1.18) | libwebkit-dev (>= 1.1.18),
               libgdk-pixbuf2.0-dev (>= 2.0),
               libgpgme11-dev,
               libvte-dev,
Standards-Version: 3.9.2
Homepage: http://plugins.geany.org
Vcs-Git: git://git.debian.org/git/pkg-geany/packages/geany-plugins.git
Vcs-Browser: http://git.debian.org/?p=pkg-geany/packages/geany-plugins.git

Package: geany-plugins
Architecture: all
Depends: geany-plugin-addons (>= ${source:Version}),
         geany-plugin-codenav (>= ${source:Version}),
         geany-plugin-debugger (>= ${source:Version}),
         geany-plugin-doc (>= ${source:Version}),
         geany-plugin-extrasel (>= ${source:Version}),
         geany-plugin-gdb (>= ${source:Version}),
         geany-plugin-gendoc (>= ${source:Version}),
         geany-plugin-gproject (>= ${source:Version}),
         geany-plugin-insertnum (>= ${source:Version}),
         geany-plugin-latex (>= ${source:Version}),
         geany-plugin-lipsum (>= ${source:Version}),
         geany-plugin-lua (>= ${source:Version}),
         geany-plugin-macro (>= ${source:Version}),
         geany-plugin-numberedbookmarks (>= ${source:Version}),
         geany-plugin-pg (>= ${source:Version}),
         geany-plugin-prj (>= ${source:Version}),
         geany-plugin-sendmail (>= ${source:Version}),
         geany-plugin-tableconvert (>= ${source:Version}),
         geany-plugin-vc (>= ${source:Version}),
         geany-plugin-prettyprinter (>= ${source:Version}),
         geany-plugin-shiftcolumn (>= ${source:Version}),
         geany-plugin-spellcheck (>= ${source:Version}),
         geany-plugin-treebrowser (>= ${source:Version}),
         geany-plugin-updatechecker (>= ${source:Version}),
         geany-plugin-webhelper (>= ${source:Version}),
         geany-plugin-xmlsnippets (>= ${source:Version}),
         ${misc:Depends}
Description: set of plugins for Geany
 This is a metapackage which installs the whole set of plugins for Geany.
 .
 Geany is a fast and lightweight IDE.

Package: geany-plugins-common
Architecture: all
Depends: geany (>= ${geany:Version}),
         ${geany:ABI},
         ${misc:Depends}
Breaks: geany-plugin-addons (<< 0.19),
        geany-plugin-doc (<< 0.19),
        geany-plugin-gdb (<< 0.19),
        geany-plugin-latex (<< 0.19),
        geany-plugin-lipsum (<< 0.19),
        geany-plugin-lua (<< 0.19),
        geany-plugin-prj (<< 0.19),
        geany-plugin-sendmail (<< 0.19),
        geany-plugin-vc (<< 0.19),
        geany-plugin-shiftcolumn (<< 0.19),
        geany-plugin-spellcheck (<< 0.19)
Description: set of plugins for Geany (translations)
 This package contains translations for the Geany Plugins. You probably do not
 want to install this package directly, but instead install one of the other
 plugins packages.

Package: geany-plugin-addons
Architecture: any
Depends: geany-plugins-common (= ${source:Version}),
         ${shlibs:Depends}, ${misc:Depends}
Description: miscellanous plugins for Geany
 This plugin adds various small addons to Geany which aren't worth an
 individual plugin, but might still be useful for people.
  * DocList: This addon places a new item in the toolbar and when clicked
    offers a menu listing all open files plus the 'Close All' and 'Close Other
    Documents' menu items. This can be useful to quickly access open files and
    switch to them.
  * OpenURI: Adds 'Open URI' and 'Copy URI' menu items to the editor menu when
    the word under the cursor looks like a URI. 'Open URI' uses the browser
    command configured in Geany to open it.
  * Tasks: The tasks plugin goes through a file being edited and picks out
    lines with "TODO" or "FIXME" in them. It collects the text after those words
    and putsthem in a new "Tasks" tab in the message window. Clicking on a task
    in thattab takes you to the line in the file where the task was defined.
  * Systray: Adds a status icon to the notification area (systray) and
    providesa simple popup menu with some basic actions. It can also be used
    to quickly show and hide the Geany main window.
 .
 Geany is a small and lightweight integrated development environment using the
 Gtk+ toolkit.

Package: geany-plugin-codenav
Architecture: any
Depends: geany-plugins-common (= ${source:Version}),
         ${shlibs:Depends}, ${misc:Depends}
Description: code navigation plugin for Geany
 This plugin adds some facilities for navigating in code using Geany, making it
 possible to:
  * Switch between header and implementation
  * Go to a file by typing its name
 .
 Geany is a small and lightweight integrated development environment using the
 Gtk+ toolkit.

Package: geany-plugin-debugger
Architecture: any
Depends: geany-plugins-common (= ${source:Version}),
         ${shlibs:Depends}, ${misc:Depends}
Description: debugger plugin for Geany
 Features:
  * Debugger panel
  * Setting target, environment variables and command line arguments
  * Breakpoints
  * Watches, autos
  * Debug terminal
  * Debugger messages window
  * Variables calltips while debugging
  * Saving debug session data in a Geany project (can be switched through
    settings)
  * Double or single panel modes
  * Hotkeys
 .
 Geany is a small and lightweight integrated development environment using the
 Gtk+ toolkit.

Package: geany-plugin-doc
Architecture: any
Depends: geany-plugins-common (= ${source:Version}),
         ${shlibs:Depends}, ${misc:Depends}
Description: documentation plugin for Geany
 Geanydoc is a plugin for the Geany IDE which is intended to be used to search
 for documentation API from different sources. It allows execution of specified
 commands on the current word at the cursor position or otherwise specified via
 a dialog to obtain this documentation. This documentation is displayed in the
 geany buffer as a tab called *DOC*, or may be displayed in an external program.
 .
 After installing this package, you'll need to enable the "Doc" plugin
 and then setup a keyword binding for it in Geany's preferences dialogue.
 .
 Geany is a small and lightweight integrated development environment using the
 GTK+ toolkit.

Package: geany-plugin-extrasel
Architecture: any
Depends: geany-plugins-common (= ${source:Version}),
         ${shlibs:Depends}, ${misc:Depends}
Description: extra selection plugin for Geany
 The Extra Selection plugin adds the following functions to Geany:-
  * Go to matching brace and select (select to matching brace)
  * Go to line and select (select to line)
  * Ctrl+Shift+Alt+Left/Right/Home/End key - same as Ctrl+Shift, but for
    rectangular selection.
  * Column mode - while active, all (Ctrl)-Shift-Arrow keys do rectangle
    selection instead of stream.
 .
 Geany is a small and lightweight integrated development environment using the
 Gtk+ toolkit.

Package: geany-plugin-gdb
Architecture: any
Depends: geany-plugins-common (= ${source:Version}),
         gdb,
         ${shlibs:Depends}, ${misc:Depends}
Description: GDB plugin for Geany
 GeanyGDB is a plugin for Geany which provides integrated debugging support
 within Geany via the GNU Debugger (gdb).
 .
 Geany is a small and lightweight integrated development environment using the
 Gtk+ toolkit.
 .
 The GNU Debugger is a source-level debugger for C, C++, Fortran, Modula 2 and
 Java programs.

Package: geany-plugin-gendoc
Architecture: any
Depends: geany-plugins-common (= ${source:Version}),
         ${shlibs:Depends}, ${misc:Depends}
Description: documentation generation plugin for Geany
 GeanyGenDoc is a plugin for Geany which provides support for automatically
 generating documentation based on comments in the source code.
 .
 Geany is a small and lightweight integrated development environment using the
 Gtk+ toolkit.


Package: geany-plugin-gproject
Architecture: any
Depends: geany-plugins-common (= ${source:Version}),
         ${shlibs:Depends}, ${misc:Depends}
Description: gproject plugin for Geany
 GProject is an extension of Geany's project management displaying a
 tree of files belonging to the project in the sidebar. In addition, it
 enables quick swapping between header and source files, searching
 project files by name and more. 
 .
 Geany is a small and lightweight integrated development environment using the
 Gtk+ toolkit.

Package: geany-plugin-insertnum
Architecture: any
Depends: geany-plugins-common (= ${source:Version}),
         ${shlibs:Depends}, ${misc:Depends}
Description: number inserting plugin for Geany
 This plugin for Geany replaces a (possibly zero-width) rectangular selection
 with integer numbers, using start/step/base etc. specified by the user. For
 practical reasons, the number of lines is limited to 500000.
 .
 Geany is a small and lightweight integrated development environment using the
 Gtk+ toolkit.

Package: geany-plugin-latex
Architecture: any
Depends: geany-plugins-common (= ${source:Version}),
         ${shlibs:Depends}, ${misc:Depends}
Description: improved LaTeX support plugin for Geany
 GeanyLaTeX is a plugin for the Geany IDE to improve work with LaTeX. Features
 include:
  * Wizard for creating a new LaTeX-document
  * Frontend for easy input of \ref{} and \label{}
  * Easy adding of special characters and environments through plugin menu entry
  * Support for adding new items to BibTeX database
  * Toolbar with commonly used format options
  * Bulk replacement and input replacement of special characters
 .
 Geany is a small and lightweight integrated development environment using the
 Gtk+ toolkit.

Package: geany-plugin-lipsum
Architecture: any
Depends: geany-plugins-common (= ${source:Version}),
         ${shlibs:Depends}, ${misc:Depends}
Description: Lorem Ipsum generator plugin for Geany
 GeanyLipsum is a plugin for Geany which implements a Lorem Ipsum generator to
 insert placeholder text into your document.
 .
 Geany is a small and lightweight integrated development environment using the
 Gtk+ toolkit.

Package: geany-plugin-lua
Architecture: any
Depends: geany-plugins-common (= ${source:Version}),
         ${shlibs:Depends}, ${misc:Depends}
Description: Lua scripting plugin for Geany
 GeanyLua is a plugin which provides a Lua scripting interface for the Geany
 IDE.
 .
 Geany is a small and lightweight integrated development environment using the
 Gtk+ toolkit.

Package: geany-plugin-macro
Architecture: any
Depends: geany-plugins-common (= ${source:Version}),
         ${shlibs:Depends}, ${misc:Depends}
Description: macro plugin for Geany
 Geanymacro is a plugin to provide user defined macros for Geany.
 This plugin allows you to record and use your own macros. Macros are
 sequences of actions that can then be repeated with a single key 
 combination. So if you had dozens of lines where you wanted to delete
 the last 2 characters, you could simple start recording, press End, 
 Backspace, Backspace, down line and then stop recording. Then simply
 trigger the macro and it would automatically edit the line and move to
 the next.
 .
 Geany is a small and lightweight integrated development environment using the
 Gtk+ toolkit.

Package: geany-plugin-numberedbookmarks
Architecture: any
Depends: geany-plugins-common (= ${source:Version}),
         ${shlibs:Depends}, ${misc:Depends}
Description: numbered bookmarks plugin for Geany
 Geanynumberedbookmarks is a plugin to provide users with 10 numbered

=== debian/rules ===
#!/usr/bin/make -f

export LDFLAGS += -Wl,--as-needed -Wl,-z,defs

GEANY_VERSION = $(shell pkg-config --modversion geany)
GEANY_ABI = geany-abi-$(shell grep 'define GEANY_ABI_VERSION' /usr/include/geany/plugindata.h | awk '{print $$3}')
GEANY_API = geany-api-$(shell grep 'define GEANY_API_VERSION' /usr/include/geany/plugindata.h | awk '{print $$3}')

# specify libexecdir to avoid cascading geany-plugins directories in /usr/lib
override_dh_auto_configure:
	dh_auto_configure -- \
		--libexecdir='$${exec_prefix}/lib' \
		--enable-addons \
		--enable-codenav \
		--enable-debugger \
		--enable-geanydoc \
		--enable-geanyextrasel \
		--enable-geanygdb \
		--enable-geanygendoc \
		--enable-geanyinsertnum \
		--enable-geanylatex \
		--enable-geanylipsum \
		--enable-geanylua \
		--enable-geanymacro \
		--enable-geanynumberedbookmarks \
		--enable-geanypg \
		--enable-geanyprj \
		--enable-geanysendmail \
		--enable-geanyvc \
		--enable-gproject \
		--enable-pretty_printer \
		--enable-shiftcolumn \
		--enable-spellcheck \
		--enable-tableconvert \
		--enable-treebrowser \
		--enable-updatechecker \
		--enable-webhelper \
		--enable-xmlsnippets

# install separate ChangeLogs for each different plugin
override_dh_installchangelogs:
	for changelog in */ChangeLog; do \
		[ ! -s $$changelog ] && continue; \
		if [ $$changelog = po/ChangeLog ]; then \
			pkg=geany-plugins-common; \
		else \
			pkg=geany-plugin-$$(dirname $$changelog | sed -e's/^geany//'); \
		fi; \
		dh_installchangelogs \
			-p$$pkg \
			$$changelog; \
	done
	dh_installchangelogs

# add geany:Version substvar to debian/*.substvars
override_dh_gencontrol:
	dh_gencontrol -- \
		"-Vgeany:Version=$(GEANY_VERSION)" \
		"-Vgeany:ABI=$(GEANY_API)" \
		"-Vgeany:ABI=$(GEANY_ABI)"

# Don't make shlibs (false positive on pretty-printer.so
override_dh_makeshlibs:

override_dh_install:
	dh_install --list-missing

%:
	dh $@

=== debian/watch ===
# Compulsory line, this is a version 3 file
version=3

http://plugins.geany.org/geany-plugins/geany-plugins-(.*).tar.gz

## geany-plugins 0.21.1.dfsg

=== wscript ===
# -*- coding: utf-8 -*-
#
# WAF build script for geany-plugins
#
# Copyright 2008-2010 Enrico Tröger <enrico(dot)troeger(at)uvena(dot)de>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
# $Id$

"""
Waf build script for Geany Plugins.

If you want to add your plugin to this build system, simply put a file called
'wscript_build' into your plugin directory and add necessary code to build your
plugin or simply copy the wscript_build file from another plugin
and adjust the values.
If special configuration is necessary, e.g. checking for dependencies of
the plugin, create a file 'wscript_configure' and put the code into.


The code of this file itself loosely follows PEP 8 with some exceptions
(line width 100 characters and some other minor things).

Requires WAF 1.6.1 and Python 2.5 (or later).
"""

import os
import tempfile
from glob import glob
from waflib import Logs, Scripting, Utils
from waflib.Tools import c_preproc
from waflib.Errors import ConfigurationError
from waflib.TaskGen import feature
from build.wafutils import (
    add_define_to_env,
    add_to_env_and_define,
    check_cfg_cached,
    get_plugins,
    get_enabled_plugins,
    get_svn_rev,
    install_docs,
    launch,
    load_intltool_if_available,
    set_lib_dir,
    setup_makefile,
    target_is_win32)


APPNAME = 'geany-plugins'
VERSION = '0.21.1'
LINGUAS_FILE = 'po/LINGUAS'

top = '.'
out = '_build_'


c_preproc.go_absolute = True
c_preproc.standard_includes = []


def configure(conf):

    conf.check_waf_version(mini='1.6.1')

    # a C compiler is the very minimum we need
    conf.load('compiler_c')

    # common for all plugins
    check_cfg_cached(conf,
                   package='gtk+-2.0',
                   atleast_version='2.12.0',
                   uselib_store='GTK',
                   mandatory=True,
                   args='--cflags --libs')
    check_cfg_cached(conf,
                   package='geany',
                   atleast_version='0.21',
                   uselib_store='GEANY',
                   mandatory=True,
                   args='--cflags --libs')

    set_lib_dir(conf)
    # SVN/GIT detection
    svn_rev = get_svn_rev(conf)
    conf.define('REVISION', svn_rev, 1)
    # GTK/Geany versions
    geany_version = conf.check_cfg(modversion='geany') or 'Unknown'
    gtk_version = conf.check_cfg(modversion='gtk+-2.0') or 'Unknown'

    load_intltool_if_available(conf)

    # build plugin list
    enabled_plugins = get_enabled_plugins(conf)

    # execute plugin specific coniguration code
    configure_plugins(conf, enabled_plugins)
    # now add the enabled_plugins to the env to remember them
    conf.env.append_value('enabled_plugins', enabled_plugins)

    setup_configuration_env(conf)
    setup_makefile(conf)
    conf.write_config_header('config.h')

    # enable debug when compiling from VCS
    if svn_rev > 0:
        conf.env.append_value('CFLAGS', '-g -DDEBUG'.split()) # -DGEANY_DISABLE_DEPRECATED

    # summary
    Logs.pprint('BLUE', 'Summary:')
    conf.msg('Install Geany Plugins ' + VERSION + ' in', conf.env['G_PREFIX'])
    conf.msg('Using GTK version', gtk_version)
    conf.msg('Using Geany version', geany_version)
    if svn_rev > 0:
        conf.msg('Compiling Subversion revision', svn_rev)
    conf.msg('Plugins to compile', ' '.join(enabled_plugins))


def configure_plugins(conf, enabled_plugins):
    # we need to iterate over the plugin directories ourselves to be able
    # to catch plugin ConfigurationError's and remove the plugin in this case
    plugins = list(enabled_plugins)
    # iterate over a copy of the list as we remove items during iteration
    for plugin in plugins:
        try:
            # this calls the configure() functions of each plugin's wscript
            conf.recurse(plugin, mandatory=False)
        except ConfigurationError:
            enabled_plugins.remove(plugin)


def setup_configuration_env(conf):
    # Windows specials
    if target_is_win32(conf):
        if conf.env['PREFIX'].lower() == tempfile.gettempdir().lower():
            # overwrite default prefix on Windows (tempfile.gettempdir() is the Waf default)
            new_prefix = os.path.join(str(conf.root), '%s-%s' % (APPNAME, VERSION))
            add_to_env_and_define(conf, 'PREFIX', new_prefix, quote=True)
        conf.env['G_PREFIX'] = conf.env['PREFIX']
        # paths
        add_to_env_and_define(conf, 'PREFIX', '', quote=True)
        add_to_env_and_define(conf, 'LIBDIR', '', quote=True)
        add_to_env_and_define(conf, 'LIBEXECDIR', '', quote=True)
        add_to_env_and_define(conf, 'DOCDIR', 'doc', quote=True)
        conf.define('LOCALEDIR', 'share/locale', 1)
        # overwrite LOCALEDIR to install message catalogues properly
        conf.env['LOCALEDIR'] = os.path.join(conf.env['G_PREFIX'], 'share/locale')
        # DATADIR is defined in objidl.h, so we remove it from config.h
        conf.undefine('DATADIR')
        add_to_env_and_define(conf, 'GEANYPLUGINS_DATADIR', 'share')
    else:
        prefix = conf.env['PREFIX']
        conf.env['G_PREFIX'] = conf.env['PREFIX']
        # DATADIR and LOCALEDIR are defined by the intltool tool
        # but they are not added to the environment, so we need to
        add_define_to_env(conf, 'DATADIR')
        add_define_to_env(conf, 'LOCALEDIR')
        conf.env['cshlib_PATTERN'] = '%s.so'
        doc_dir = '%s/doc/geany-plugins' % conf.env['DATADIR']
        conf.define('PREFIX', prefix, quote=True)
        add_to_env_and_define(conf, 'DOCDIR', doc_dir, quote=True)
        add_to_env_and_define(conf, 'GEANYPLUGINS_DATADIR', conf.env['DATADIR'], quote=True)
        conf.env['GEANYPLUGINS_DATADIR'] = conf.env['DATADIR']
    # common
    pkgdatadir = os.path.join(conf.env['GEANYPLUGINS_DATADIR'], 'geany-plugins')
    pkglibdir = os.path.join(conf.env['LIBDIR'], 'geany-plugins')
    add_to_env_and_define(conf, 'PKGDATADIR', pkgdatadir, quote=True)
    add_to_env_and_define(conf, 'PKGLIBDIR', pkglibdir, quote=True)
    add_to_env_and_define(conf, 'VERSION', VERSION, quote=True)
    add_to_env_and_define(conf, 'PACKAGE', APPNAME, quote=True)
    add_to_env_and_define(conf, 'GETTEXT_PACKAGE', APPNAME, quote=True)
    add_to_env_and_define(conf, 'ENABLE_NLS', 1)

    conf.env.append_value('CFLAGS', ['-DHAVE_CONFIG_H'])


def options(opt):
    opt.tool_options('compiler_cc')
    opt.tool_options('intltool')

    plugins = get_plugins()

    # execute plugin specific option code
    opt.recurse(plugins, mandatory=False)

    # Paths
    opt.add_option('--libdir', type='string', default='',
        help='object code libraries', dest='libdir')
    opt.add_option('--libexecdir', type='string', default='',
        help='program executables', dest='libexecdir')
    # Actions
    opt.add_option('--list-plugins', action='store_true', default=False,
        help='list plugins which can be built', dest='list_plugins')

    opt.add_option('--enable-plugins', action='store', default='',
        help='plugins to be built [plugins in CSV format, e.g. "%(1)s,%(2)s"]' % \
        { '1' : plugins[0], '2' : plugins[1] }, dest='enable_plugins')
    opt.add_option('--skip-plugins', action='store', default='',
        help='plugins which should not be built, ignored when --enable-plugins is set, same format as --enable-plugins',
        dest='skip_plugins')


def build(bld):
    is_win32 = target_is_win32(bld)
    enabled_plugins = bld.env['enabled_plugins']

    if bld.cmd == 'clean':
        remove_linguas_file()
    if bld.cmd in ('install', 'uninstall'):
        bld.add_post_fun(_post_install)

    if bld.env['INTLTOOL']:
        install_path = '${G_PREFIX}/share/locale' if is_win32 else '${LOCALEDIR}'
        bld.new_task_gen(
            features     = ['linguas', 'intltool_po'],
            podir        = 'po',
            appname      = APPNAME,
            install_path = install_path)

    # install additional docs
    install_docs(bld, '', ('README', 'NEWS'))
    if is_win32:
        bld.install_as('${G_PREFIX}/ReadMe.Windows.txt', 'README.windows')

    # execute plugin specific build code
    bld.recurse(enabled_plugins)


def _post_install(ctx):
    is_win32 = target_is_win32(ctx)
    if is_win32:
        return
    theme_dir = Utils.subst_vars('${DATADIR}/icons/hicolor', ctx.env)
    icon_cache_updated = False
    if not ctx.options.destdir:
        ctx.exec_command('gtk-update-icon-cache -q -f -t %s' % theme_dir)
        Logs.pprint('GREEN', 'GTK icon cache updated.')
        icon_cache_updated = True
    if not icon_cache_updated:
        Logs.pprint('YELLOW', 'Icon cache not updated. After install, run this:')
        Logs.pprint('YELLOW', 'gtk-update-icon-cache -q -f -t %s' % theme_dir)


def init(ctx):
    if ctx.options.list_plugins:
        listplugins(ctx)


def listplugins(ctx):
    """list plugins which can be built"""
    plugins = get_plugins()
    Logs.pprint('GREEN', 'The following targets can be chosen with the --enable-plugins option:')
    Logs.pprint('NORMAL', ' '.join(plugins))

    Logs.pprint('GREEN', \
    '\nTo compile only "%(1)s" and "%(2)s", use "./waf configure --enable-plugins=%(1)s,%(2)s".' % \
            { '1' : plugins[0], '2' : plugins[1] } )
    exit(0)


def distclean(ctx):
    Scripting.distclean(ctx)
    remove_linguas_file()


def remove_linguas_file():
    # remove LINGUAS file as well
    try:
        os.unlink(LINGUAS_FILE)
    except OSError:
        pass


@feature('linguas')
def write_linguas_file(self):
    if os.path.exists(LINGUAS_FILE):
        return
    linguas = ''
    if 'LINGUAS' in self.env:
        files = self.env['LINGUAS']
        for po_filename in files.split(' '):
            if os.path.exists ('po/%s.po' % po_filename):
                linguas += '%s ' % po_filename
    else:
        files = os.listdir('%s/po' % self.path.abspath())
        files.sort()
        for filename in files:
            if filename.endswith('.po'):
                linguas += '%s ' % filename[:-3]
    file_h = open(LINGUAS_FILE, 'w')
    file_h.write('# This file is autogenerated. Do not edit.\n%s\n' % linguas)
    file_h.close()


def create_installer(ctx):
    """create the Windows installer (maintainer and Win32 only)"""
    # must be called *after* everything has been installed
    do_sign = os.path.exists('sign.bat') # private file to sign the binary files, not needed
    def sign_binary(filename):
        if do_sign:
            ctx.exec_command('sign.bat %s' % filename)

    # strip all binaries
    Logs.pprint('CYAN', 'Stripping %sfiles' % ('and signing binary ' if do_sign else ''))
    install_dir = '%s-%s' % (APPNAME, VERSION) # should be ctx.env['G_PREFIX']
    files = glob(os.path.join(install_dir, 'lib', '*.dll'))
    files.append(os.path.join(install_dir, 'lib\geany-plugins\geanylua\libgeanylua.dll'))
    for filename in files: # sign the DLL files
        ctx.exec_command('strip %s' % filename)
        sign_binary(filename)
    # create the installer
    launch(ctx, 'makensis /V2 /NOCD build/geany-plugins.nsi', 'Creating the installer', 'CYAN')
    sign_binary('geany-plugins-%s_setup.exe' % VERSION)


def updatepo(ctx):
    """update the message catalogs for internationalization"""
    potfile = '%s.pot' % APPNAME
    os.chdir('%s/po' % top)
    try:
        try:
            old_size = os.stat(potfile).st_size

=== debian/changelog ===
geany-plugins (0.21.1.dfsg-4) unstable; urgency=low

  * [f53b3da] Use new project preference open/close signals in the
    gproject plugin.

 -- Evgeni Golov <evgeni@debian.org>  Tue, 26 Jun 2012 21:02:26 +0200

geany-plugins (0.21.1.dfsg-3) unstable; urgency=low

  [ Chow Loong Jin ]
  * [d75948f] Fix dversionmangle in debian/watch

  [ Evgeni Golov ]
  * [4fd29dc] Build-Depend on dh-autoreconf >= 4 as this introduced
    --as-needed
  * [e7ec0a4] move geany-abi Depends from geany-plugins-common to the
    individual plugins
  * [36bbc4f] Standards-Version: 3.9.3
  * [c0e3469] Build-Depends: debhelper (>= 9)

 -- Evgeni Golov <evgeni@debian.org>  Tue, 19 Jun 2012 20:47:33 +0200

geany-plugins (0.21.1.dfsg-2) unstable; urgency=low

  * [9e2298b] Add gmodule-2.0 to geanylua deps.
    This fixes an FTBFS while linking geanylua due to missing symbols in Ubuntu
    Precise. (LP: #935110)
  * [becc080] Use dh-autoreconf.
    Also drop 99_ltmain_as-needed.patch as dh-autoreconf handles the patching.

 -- Chow Loong Jin <hyperair@debian.org>  Sun, 19 Feb 2012 02:03:04 +0800

geany-plugins (0.21.1.dfsg-1) unstable; urgency=low

  * [1439d18] Add Enhances: geany to all plugins and metapackage
  * [aefccbd] Fix typo in specifying geany:API substvar
  * [c86590d] Add version to libvte-dev build-dep
  * [dff6cc0] Implement repacking of tarball to remove waf
  * [ba9f6b4] Imported Upstream version 0.21.1.dfsg (Closes: #654467)
  * [1568b1f] Change my email address

 -- Chow Loong Jin <hyperair@debian.org>  Fri, 06 Jan 2012 02:11:03 +0800

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,9 @@
 Section: devel
 Priority: optional
 Maintainer: Geany Packaging Team <pkg-geany-team@lists.alioth.debian.org>
-Uploaders: Chow Loong Jin <hyperair@ubuntu.com>, Evgeni Golov <evgeni@debian.org>
-Build-Depends: debhelper (>= 8.9.0~),
+Uploaders: Chow Loong Jin <hyperair@debian.org>, Evgeni Golov <evgeni@debian.org>
+Build-Depends: debhelper (>= 9),
+               dh-autoreconf (>= 4),
                autotools-dev,
                intltool (>= 0.35),
                geany (>= 0.21),
@@ -19,14 +20,15 @@
                libwebkitgtk-dev (>= 1.1.18) | libwebkit-dev (>= 1.1.18),
                libgdk-pixbuf2.0-dev (>= 2.0),
                libgpgme11-dev,
-               libvte-dev,
-Standards-Version: 3.9.2
+               libvte-dev (>= 0.24)
+Standards-Version: 3.9.3
 Homepage: http://plugins.geany.org
 Vcs-Git: git://git.debian.org/git/pkg-geany/packages/geany-plugins.git
 Vcs-Browser: http://git.debian.org/?p=pkg-geany/packages/geany-plugins.git
 
 Package: geany-plugins
 Architecture: all
+Enhances: geany
 Depends: geany-plugin-addons (>= ${source:Version}),
          geany-plugin-codenav (>= ${source:Version}),
          geany-plugin-debugger (>= ${source:Version}),
@@ -62,7 +64,6 @@
 Package: geany-plugins-common
 Architecture: all
 Depends: geany (>= ${geany:Version}),
-         ${geany:ABI},
          ${misc:Depends}
 Breaks: geany-plugin-addons (<< 0.19),
         geany-plugin-doc (<< 0.19),
@@ -81,8 +82,9 @@
  plugins packages.
 
 Package: geany-plugin-addons
-Architecture: any
-Depends: geany-plugins-common (= ${source:Version}),
+Enhances: geany
+Architecture: any
+Depends: ${geany:ABI}, geany-plugins-common (= ${source:Version}),
          ${shlibs:Depends}, ${misc:Depends}
 Description: miscellanous plugins for Geany
  This plugin adds various small addons to Geany which aren't worth an
@@ -106,8 +108,9 @@
  Gtk+ toolkit.
 
 Package: geany-plugin-codenav
-Architecture: any
-Depends: geany-plugins-common (= ${source:Version}),
+Enhances: geany
+Architecture: any
+Depends: ${geany:ABI}, geany-plugins-common (= ${source:Version}),
          ${shlibs:Depends}, ${misc:Depends}
 Description: code navigation plugin for Geany
  This plugin adds some facilities for navigating in code using Geany, making it
@@ -119,8 +122,9 @@
  Gtk+ toolkit.
 
 Package: geany-plugin-debugger
-Architecture: any
-Depends: geany-plugins-common (= ${source:Version}),
+Enhances: geany
+Architecture: any
+Depends: ${geany:ABI}, geany-plugins-common (= ${source:Version}),
          ${shlibs:Depends}, ${misc:Depends}
 Description: debugger plugin for Geany
  Features:
@@ -140,8 +144,9 @@
  Gtk+ toolkit.
 
 Package: geany-plugin-doc
-Architecture: any
-Depends: geany-plugins-common (= ${source:Version}),
+Enhances: geany
+Architecture: any
+Depends: ${geany:ABI}, geany-plugins-common (= ${source:Version}),
          ${shlibs:Depends}, ${misc:Depends}
 Description: documentation plugin for Geany
  Geanydoc is a plugin for the Geany IDE which is intended to be used to search
@@ -157,8 +162,9 @@
  GTK+ toolkit.
 
 Package: geany-plugin-extrasel
-Architecture: any
-Depends: geany-plugins-common (= ${source:Version}),
+Enhances: geany
+Architecture: any
+Depends: ${geany:ABI}, geany-plugins-common (= ${source:Version}),
          ${shlibs:Depends}, ${misc:Depends}
 Description: extra selection plugin for Geany
  The Extra Selection plugin adds the following functions to Geany:-
@@ -173,8 +179,9 @@
  Gtk+ toolkit.
 
 Package: geany-plugin-gdb
-Architecture: any
-Depends: geany-plugins-common (= ${source:Version}),
+Enhances: geany
+Architecture: any
+Depends: ${geany:ABI}, geany-plugins-common (= ${source:Version}),
          gdb,
          ${shlibs:Depends}, ${misc:Depends}
 Description: GDB plugin for Geany
@@ -188,8 +195,9 @@
  Java programs.
 
 Package: geany-plugin-gendoc
-Architecture: any
-Depends: geany-plugins-common (= ${source:Version}),
+Enhances: geany
+Architecture: any
+Depends: ${geany:ABI}, geany-plugins-common (= ${source:Version}),
          ${shlibs:Depends}, ${misc:Depends}
 Description: documentation generation plugin for Geany
  GeanyGenDoc is a plugin for Geany which provides support for automatically
@@ -200,8 +208,9 @@
 
 
 Package: geany-plugin-gproject
-Architecture: any
-Depends: geany-plugins-common (= ${source:Version}),
+Enhances: geany
+Architecture: any
+Depends: ${geany:ABI}, geany-plugins-common (= ${source:Version}),
          ${shlibs:Depends}, ${misc:Depends}
 Description: gproject plugin for Geany
  GProject is an extension of Geany's project management displaying a
@@ -213,8 +222,9 @@
  Gtk+ toolkit.
 
 Package: geany-plugin-insertnum
-Architecture: any
-Depends: geany-plugins-common (= ${source:Version}),
+Enhances: geany
+Architecture: any
+Depends: ${geany:ABI}, geany-plugins-common (= ${source:Version}),
          ${shlibs:Depends}, ${misc:Depends}
 Description: number inserting plugin for Geany
  This plugin for Geany replaces a (possibly zero-width) rectangular selection
@@ -225,8 +235,9 @@
  Gtk+ toolkit.
 
 Package: geany-plugin-latex
-Architecture: any
-Depends: geany-plugins-common (= ${source:Version}),
+Enhances: geany
+Architecture: any
+Depends: ${geany:ABI}, geany-plugins-common (= ${source:Version}),
          ${shlibs:Depends}, ${misc:Depends}
 Description: improved LaTeX support plugin for Geany
  GeanyLaTeX is a plugin for the Geany IDE to improve work with LaTeX. Features
@@ -242,8 +253,9 @@
  Gtk+ toolkit.
 
 Package: geany-plugin-lipsum
-Architecture: any
-Depends: geany-plugins-common (= ${source:Version}),
+Enhances: geany
+Architecture: any
+Depends: ${geany:ABI}, geany-plugins-common (= ${source:Version}),
          ${shlibs:Depends}, ${misc:Depends}
 Description: Lorem Ipsum generator plugin for Geany
  GeanyLipsum is a plugin for Geany which implements a Lorem Ipsum generator to
@@ -253,8 +265,9 @@
  Gtk+ toolkit.
 
 Package: geany-plugin-lua
-Architecture: any
-Depends: geany-plugins-common (= ${source:Version}),
+Enhances: geany
+Architecture: any
+Depends: ${geany:ABI}, geany-plugins-common (= ${source:Version}),
          ${shlibs:Depends}, ${misc:Depends}
 Description: Lua scripting plugin for Geany
  GeanyLua is a plugin which provides a Lua scripting interface for the Geany
@@ -264,8 +277,9 @@
  Gtk+ toolkit.
 
 Package: geany-plugin-macro
-Architecture: any
-Depends: geany-plugins-common (= ${source:Version}),
+Enhances: geany
+Architecture: any
+Depends: ${geany:ABI}, geany-plugins-common (= ${source:Version}),
          ${shlibs:Depends}, ${misc:Depends}
 Description: macro plugin for Geany
  Geanymacro is a plugin to provide user defined macros for Geany.
@@ -274,15 +288,3 @@
  combination. So if you had dozens of lines where you wanted to delete
  the last 2 characters, you could simple start recording, press End, 
  Backspace, Backspace, down line and then stop recording. Then simply
- trigger the macro and it would automatically edit the line and move to
- the next.
- .
- Geany is a small and lightweight integrated development environment using the
- Gtk+ toolkit.
-
-Package: geany-plugin-numberedbookmarks
-Architecture: any
-Depends: geany-plugins-common (= ${source:Version}),
-         ${shlibs:Depends}, ${misc:Depends}
-Description: numbered bookmarks plugin for Geany
- Geanynumberedbookmarks is a plugin to provide users with 10 numbered

=== debian/rules ===
--- 
+++ 
@@ -5,6 +5,9 @@
 GEANY_VERSION = $(shell pkg-config --modversion geany)
 GEANY_ABI = geany-abi-$(shell grep 'define GEANY_ABI_VERSION' /usr/include/geany/plugindata.h | awk '{print $$3}')
 GEANY_API = geany-api-$(shell grep 'define GEANY_API_VERSION' /usr/include/geany/plugindata.h | awk '{print $$3}')
+
+override_dh_autoreconf:
+	dh_autoreconf --as-needed
 
 # specify libexecdir to avoid cascading geany-plugins directories in /usr/lib
 override_dh_auto_configure:
@@ -56,7 +59,7 @@
 override_dh_gencontrol:
 	dh_gencontrol -- \
 		"-Vgeany:Version=$(GEANY_VERSION)" \
-		"-Vgeany:ABI=$(GEANY_API)" \
+		"-Vgeany:API=$(GEANY_API)" \
 		"-Vgeany:ABI=$(GEANY_ABI)"
 
 # Don't make shlibs (false positive on pretty-printer.so
@@ -66,4 +69,16 @@
 	dh_install --list-missing
 
 %:
-	dh $@
+	dh $@ --with=autoreconf
+
+upstream_version ?= $(shell dpkg-parsechangelog | sed -rne 's/^Version: ([0-9.]+)(\.dfsg)?.*$$/\1/p')
+dfsg_version = $(upstream_version).dfsg
+pkg = $(shell dpkg-parsechangelog | sed -ne 's/^Source: //p')
+
+get-orig-source:
+	uscan --noconf --force-download --rename --repack --download-current-version --destdir=.
+	tar -xzf $(pkg)_$(upstream_version).orig.tar.gz
+	mv $(pkg)-$(upstream_version) $(pkg)-$(dfsg_version)
+	rm $(pkg)-$(dfsg_version)/waf
+	GZIP="-9fn --rsyncable" tar -czf $(pkg)_$(dfsg_version).orig.tar.gz $(pkg)-$(dfsg_version)
+	rm -rf $(pkg)-$(dfsg_version)

=== debian/watch ===
# Compulsory line, this is a version 3 file
version=3

opts=dversionmangle=s/\.dfsg(\.\d+)?$// \
http://plugins.geany.org/geany-plugins/geany-plugins-(.*).tar.gz

## geany-plugins 1.23%2Bdfsg

=== debian/changelog ===
geany-plugins (1.23+dfsg-3) unstable; urgency=low

  * No-change upload to unstable now that freeze is over

 -- Chow Loong Jin <hyperair@debian.org>  Fri, 10 May 2013 15:45:38 +0800

geany-plugins (1.23+dfsg-2) experimental; urgency=low

  * [c25de03] Add reference to /usr/share/common-licenses/GPL-1
  * [f1273ba] Include buildflags.mk.
    This fixes hardening-no-relro, which was caused by us overriding LDFLAGS.
  * [db37f6b] Drop hardening-no-relro from lintian overrides

 -- Chow Loong Jin <hyperair@debian.org>  Sun, 31 Mar 2013 18:02:38 +0800

geany-plugins (1.23+dfsg-1) experimental; urgency=low

  [ Chow Loong Jin ]
  * [d617de5] Imported Upstream version 1.23
  * [fa625d4] Update configure flags

  [ Evgeni Golov ]
  * [ea13bdb] drop patch against geanylatex, applied upstream
  * [e1d875e] drop geany-plugin-gdb, it's not shipped upstream anymore
  * [4c980c5] enable the markdown plugin
  * [c8f6e33] create packages for the new plugins and install them there
  * [aac1b14] load help files from Debian's locations
  * [64e1be8] use libmarkdown instead of peg markdown
  * [762e8e0] update d/copyright for the added and removed plugins

  [ Chow Loong Jin ]
  * [c127275] Bump geany build-dep
  * [e1a066a] Override hardening-no-relro
  * [22845f0] Bump Standards-Version to 3.9.4
  * [8f028e0] Add MIT and GPL-1+ paragraphs

 -- Chow Loong Jin <hyperair@debian.org>  Sun, 31 Mar 2013 01:43:01 +0800

geany-plugins (1.22+dfsg-2) experimental; urgency=low

  * [84061f4] Update copyright file
  * [418a783] Enable parallel builds

 -- Chow Loong Jin <hyperair@debian.org>  Thu, 12 Jul 2012 18:26:52 +0800

geany-plugins (1.22+dfsg-1) experimental; urgency=low

  * [8cc36bf] Add missing epoch to libvte-dev build-dep
  * [62e2e05] Imported Upstream version 1.22
  * [f266578] Create packages for new plugins
    - geany-plugin-devhelp
    - geany-plugin-geniuspaste
    - geany-plugin-miniscript
    - geany-plugin-multiterm
  * [2d89ff4] Update geany version in build-deps
  * [372a69e] Drop all patches (applied upstream)
  * [cbc8c50] Add build-deps for devhelp and multiterm plugins
    - libwnck-dev
    - libgconf2-dev
    - valac
  * [62b114a] Update g-p-prettyprinter.install
    pretty-print.so was renamed to pretty-printer.so
  * [aaf46de] Patch geanylatex to install its docs correctly
  * [ec6b40a] Use +dfsg instead of .dfsg

 -- Chow Loong Jin <hyperair@debian.org>  Thu, 12 Jul 2012 17:07:42 +0800
